#!/usr/local/bin/python 
###
# calculate 2nd-order Mrakov model
#	base order : ACGT
# this is for Leave-one-out calculation
###
from Numeric import *

BG={}
#Background probabilit in Ceni: 0th order Markov Model
BG["A"] = 0.1672
BG["C"] = 0.3328
BG["G"] = 0.3328
BG["T"] = 0.1672

#nexfile = open("align_nex/align_up32.nex","r")
nexfile = open("align_nex/align_dw22.nex","r")
nexdata = nexfile.readlines()
nexdata = nexdata[8:-4]
for i in range (len(nexdata)):
	nexdata[i] = nexdata[i].replace("\n","")
	nexdata[i] = nexdata[i].replace("\t","")
	nexdata[i] = nexdata[i].replace("'","")
	nexdata[i] = nexdata[i].split()

outfile = open("align_matrix_loo_0th/align_dw20.txt","w")
#initialization
N = {}
S = {}
for x in "ACGT":
	N[x] = zeros(32,Float)
	S[x] = zeros(32,Float)

for i in range (len(nexdata)):
	for j in range(len(nexdata[i][-1])):
		for x in "ACGT":
			if(nexdata[i][-1][j] == x):
				N[x][j] += 1

tnum = len(nexdata)-1
B = sqrt(tnum)
printout = ""
for i in range(len(nexdata[0][-1]))[2:]:	#[2:] : bacause original file is for 2nd order
	for x in "ACGT":
		S[x][i] = log(((N[x][i]+B*BG[x])/(tnum+B)) / BG[x])
		printout = printout + "%.4f\t" % (S[x][i])
	printout = printout[:-1]	#remove the last tab(\t)
	printout = printout + "\n"
printout = printout[:-1]	#remove the last return(\n)
outfile.write(printout)
	